searchNodes=[{"doc":"The configuration for mate deployments is stored in your applications root directory, in a file named .mate.exs . This uses import Config as you might already be used to. To get started you can use the mix task mix mate.init to help generate one for you. The configuration exists out of two parts: 1. Mate configuration This configures mate itself, a full example would be: config :mate , otp_app : :my_app , driver : Mate.Driver.SSH , mix_env : :prod , clean_paths : ~w{_build rel priv/generated priv/static} You can also customise the build steps that are executed, but more information about that can be found in Mate.Pipeline . 2. Remote configuration You can specify one or more remotes, for example you could configure a staging and production environment. But you can add as many as you want, with whichever names you want to use. A remote ends up as a %Mate.Remote{} struct, so a very complete example is: config :staging , build_server : &quot;build.example.com&quot; , deploy_server : &quot;www.example.com&quot; , build_path : &quot;/tmp/build/my-app&quot; , release_path : &quot;/opt/my-app&quot; , build_secrets : %{ &quot;prod.secret.exs&quot; =&gt; &quot;/home/elixir/secrets/prod.secret.exs&quot; } If both servers are the same you can also opt to just configure server instead of having to specify both build_server and deploy_server . For small setups it might be more likely for you to not have a separate build server yet. config :staging , server : &quot;www.example.com&quot; , You can also specify multiple deploy servers by turning them into a list as such: config :staging , deploy_server : [ &quot;www1.example.com&quot; , &quot;www2.example.com&quot; , &quot;www3.example.com&quot; ]","ref":"Mate.Config.html","title":"Mate.Config","type":"module"},{"doc":"Find a specific remote in the given config, or if there was no specific search query given it will just return the first one found as the default. This will return as a tuple.","ref":"Mate.Config.html#find_remote/2","title":"Mate.Config.find_remote/2","type":"function"},{"doc":"Find a specific remote in the given config, or if there was no specific search query given it will just return the first one found as the default. This will return a Mate.Remote struct or raise an error when there was nothing found.","ref":"Mate.Config.html#find_remote!/2","title":"Mate.Config.find_remote!/2","type":"function"},{"doc":"Reads and parses the given configuration file.","ref":"Mate.Config.html#read!/1","title":"Mate.Config.read!/1","type":"function"},{"doc":"","ref":"Mate.Config.html#t:t/0","title":"Mate.Config.t/0","type":"type"},{"doc":"This is the behaviour for Mate Drivers. The idea behind supporting multiple drivers is allowing the user to decide how and where they want to build their application. By default is will use the SSH driver, but maybe in the near future there will be other built-in drivers. It is also possible to write your own, of course. For an example I recommend looking at Mate.Driver.SSH . NOTE: Deployments currently always use the Mate.Driver.SSH .","ref":"Mate.Driver.html","title":"Mate.Driver","type":"behaviour"},{"doc":"This one is optional and can be used to close the current connection, cleanup or whatever else might be needed.","ref":"Mate.Driver.html#c:close/1","title":"Mate.Driver.close/1","type":"callback"},{"doc":"Copy a file from remote to local","ref":"Mate.Driver.html#c:copy_from/3","title":"Mate.Driver.copy_from/3","type":"callback"},{"doc":"Copy a file from local to remote","ref":"Mate.Driver.html#c:copy_to/3","title":"Mate.Driver.copy_to/3","type":"callback"},{"doc":"Returns a description of the current host (defaults to context hostname)","ref":"Mate.Driver.html#c:current_host/1","title":"Mate.Driver.current_host/1","type":"callback"},{"doc":"Executes a command using the driver","ref":"Mate.Driver.html#c:exec/3","title":"Mate.Driver.exec/3","type":"callback"},{"doc":"Executes a script using the driver","ref":"Mate.Driver.html#c:exec_script/2","title":"Mate.Driver.exec_script/2","type":"callback"},{"doc":"Prepare source","ref":"Mate.Driver.html#c:prepare_source/1","title":"Mate.Driver.prepare_source/1","type":"callback"},{"doc":"Starts the driver, for example create an SSH connection, start a docker container, or whatever else might be needed for your new session.","ref":"Mate.Driver.html#c:start/2","title":"Mate.Driver.start/2","type":"callback"},{"doc":"The Docker driver is used to execute commands via Docker. Configure the image you want to use by setting it in the driver_opts Keyword list in your .mate.exs configuration file. For example: config :mate , driver : Mate.Driver.Docker , driver_opts : [ image : &quot;bitwalker/alpine-elixir-phoenix&quot; ] It will mount your current repository in /repo , but it will clone your latest commit to the specified build_path . If you have a secret file you want locally you can link it from /repo . For example: config :staging , server : &quot;www.example.com&quot; , build_path : &quot;/tmp/mate/my-app&quot; , build_secrets : %{ &quot;prod.secret.exs&quot; =&gt; &quot;/repo/config/prod.secret.exs&quot; }","ref":"Mate.Driver.Docker.html","title":"Mate.Driver.Docker","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Mate.Driver.Docker.html#child_spec/1","title":"Mate.Driver.Docker.child_spec/1","type":"function"},{"doc":"The Local driver is used to execute commands on your local machine. Be aware that if you want to deploy your application on another machine, they must match system architectures. For example if you build locally on MacOS you cannot deploy the application to Ubuntu. Example configuration: config :mate , otp_app : :example , module : Example , driver : Mate.Driver.Local config :staging , server : &quot;www.example.com&quot; , build_path : &quot;/tmp/mate/example&quot; , release_path : &quot;/home/elixir/releases/example&quot; , build_secrets : %{ &quot;prod.secret.exs&quot; =&gt; &quot; \#{ File . cwd! ( ) } /config/prod.secret.exs&quot; }","ref":"Mate.Driver.Local.html","title":"Mate.Driver.Local","type":"module"},{"doc":"The SSH driver is used to execute commands via SSH. It will maintain a connection using ControlMaster and send commands and/or files over that connection, instead of reconnecting for every given command.","ref":"Mate.Driver.SSH.html","title":"Mate.Driver.SSH","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Mate.Driver.SSH.html#child_spec/1","title":"Mate.Driver.SSH.child_spec/1","type":"function"},{"doc":"The Test driver is used for testing.","ref":"Mate.Driver.Test.html","title":"Mate.Driver.Test","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Mate.Driver.Test.html#child_spec/1","title":"Mate.Driver.Test.child_spec/1","type":"function"},{"doc":"","ref":"Mate.Driver.Test.html#response_for/3","title":"Mate.Driver.Test.response_for/3","type":"function"},{"doc":"","ref":"Mate.Driver.Test.html#sandbox/1","title":"Mate.Driver.Test.sandbox/1","type":"function"},{"doc":"This module contains helper functions that can be used to execute commands on the local machine, or the remote machine using the configured driver ƒrom .mate.exs . It also have functions to copy files from or to the remote server. These helpers are automatically imported in a custom Mate.Pipeline.Step . For example: defmodule CustomHelloUser do use Mate.Pipeline.Step @impl true def run ( session ) do { :ok , user } = remote_cmd ( session , &quot;whoami&quot; ) IO . puts &quot;Hello &quot; &lt;&gt; user { :ok , session } end end","ref":"Mate.Helpers.html","title":"Mate.Helpers","type":"module"},{"doc":"Safely terminate connections and raises error","ref":"Mate.Helpers.html#bail/3","title":"Mate.Helpers.bail/3","type":"function"},{"doc":"Copy a file from the remote server to the local machine","ref":"Mate.Helpers.html#copy_from/3","title":"Mate.Helpers.copy_from/3","type":"function"},{"doc":"Copy a file from your local machine to the remote server","ref":"Mate.Helpers.html#copy_to/3","title":"Mate.Helpers.copy_to/3","type":"function"},{"doc":"Execute a command (with arguments) on the local machine","ref":"Mate.Helpers.html#local_cmd/3","title":"Mate.Helpers.local_cmd/3","type":"function"},{"doc":"Execute a script on the local machine","ref":"Mate.Helpers.html#local_script/2","title":"Mate.Helpers.local_script/2","type":"function"},{"doc":"Execute a command (with arguments) on the remote machine","ref":"Mate.Helpers.html#remote_cmd/3","title":"Mate.Helpers.remote_cmd/3","type":"function"},{"doc":"Execute a script on the remote machine","ref":"Mate.Helpers.html#remote_script/2","title":"Mate.Helpers.remote_script/2","type":"function"},{"doc":"This module keeps track of the build and deploy pipelines. It will use the given steps from your Mate.Config to either build or deploy your application on the specified servers. The default steps will attempt to sniff whether or not you are in need of the assets pipeline, which uses npm by default. The pipeline can be updated with custom steps using the configuration file .mate.exs , for example you can add a custom step module with the Mate.Pipeline.Step behaviour. config :mate , steps : fn steps , pipeline -&gt; pipeline . insert_before ( steps , Mate.Step.CleanBuild , CustomStep ) end , defmodule CustomStep do use Mate.Pipeline.Step @impl true def run ( session ) do IO . puts ( &quot;Execute my custom code&quot; ) { :ok , session } end end You can also use useful commands like local_cmd/2 , local_cmd/3 , local_script/2 , remote_cmd/2 , remote_cmd/3 , remote_script/2 , copy_from/3 and copy_to/3 to interact with the local machine or with the build server in various ways.","ref":"Mate.Pipeline.html","title":"Mate.Pipeline","type":"module"},{"doc":"Returns list of default build steps.","ref":"Mate.Pipeline.html#default_steps/0","title":"Mate.Pipeline.default_steps/0","type":"function"},{"doc":"Inserts a custom step in the given steps after a specific spec. Example: pipeline . insert_after ( steps , Mate.Step.CleanBuild , CustomStep )","ref":"Mate.Pipeline.html#insert_after/3","title":"Mate.Pipeline.insert_after/3","type":"function"},{"doc":"Inserts a custom step in the given steps before a specific spec. Example: pipeline . insert_before ( steps , Mate.Step.CleanBuild , CustomStep )","ref":"Mate.Pipeline.html#insert_before/3","title":"Mate.Pipeline.insert_before/3","type":"function"},{"doc":"Create a new Pipeline struct with default build steps","ref":"Mate.Pipeline.html#new/0","title":"Mate.Pipeline.new/0","type":"function"},{"doc":"Create a new Pipeline struct with custom steps","ref":"Mate.Pipeline.html#new/1","title":"Mate.Pipeline.new/1","type":"function"},{"doc":"Removes a specific step from the given steps. Example: pipeline . remove ( steps , Mate.Step.CleanBuild )","ref":"Mate.Pipeline.html#remove/2","title":"Mate.Pipeline.remove/2","type":"function"},{"doc":"Replaces a specific step with a custom step in the given steps Example: pipeline . replace ( steps , Mate.Step.CleanBuild , CustomStep )","ref":"Mate.Pipeline.html#replace/3","title":"Mate.Pipeline.replace/3","type":"function"},{"doc":"Runs all steps within a given session for the given context, using the driver from your configuration file. For build context it will use the build_server and for deploy context it will run on all deploy servers.","ref":"Mate.Pipeline.html#run/1","title":"Mate.Pipeline.run/1","type":"function"},{"doc":"Run a specific step within the current session.","ref":"Mate.Pipeline.html#run_step/2","title":"Mate.Pipeline.run_step/2","type":"function"},{"doc":"","ref":"Mate.Pipeline.html#t:step/0","title":"Mate.Pipeline.step/0","type":"type"},{"doc":"","ref":"Mate.Pipeline.html#t:steps/0","title":"Mate.Pipeline.steps/0","type":"type"},{"doc":"","ref":"Mate.Pipeline.html#t:t/0","title":"Mate.Pipeline.t/0","type":"type"},{"doc":"This behaviour is used for every step in the pipeline","ref":"Mate.Pipeline.Step.html","title":"Mate.Pipeline.Step","type":"behaviour"},{"doc":"Run this step within the given session","ref":"Mate.Pipeline.Step.html#c:run/1","title":"Mate.Pipeline.Step.run/1","type":"callback"},{"doc":"This module stores all information about a remote. A remote in mate is your server environment, e.g. staging or production.","ref":"Mate.Remote.html","title":"Mate.Remote","type":"module"},{"doc":"Creates a new Mate.Remote stuct with the given id and parameters.","ref":"Mate.Remote.html#new/2","title":"Mate.Remote.new/2","type":"function"},{"doc":"","ref":"Mate.Remote.html#t:t/0","title":"Mate.Remote.t/0","type":"type"},{"doc":"This module contains all relevant information to the current session when running the mate.deploy mix task. It keeps track of the current configuration, build pipeline, assigns that can be used to transfer information between build steps, the current context to determine wheter this is a building session or a deploying session, and more!","ref":"Mate.Session.html","title":"Mate.Session","type":"module"},{"doc":"Creates a new Mate.Session struct based on the given config file and optionally any other options can be set.","ref":"Mate.Session.html#new/2","title":"Mate.Session.new/2","type":"function"},{"doc":"","ref":"Mate.Session.html#t:t/0","title":"Mate.Session.t/0","type":"type"},{"doc":"This removes the specified config.clean_paths .","ref":"Mate.Step.CleanBuild.html","title":"Mate.Step.CleanBuild","type":"module"},{"doc":"Copies the release tarball to remote deploy servers.","ref":"Mate.Step.CopyToDeployHost.html","title":"Mate.Step.CopyToDeployHost","type":"module"},{"doc":"This copies the release tarball to your local machine.","ref":"Mate.Step.CopyToStorage.html","title":"Mate.Step.CopyToStorage","type":"module"},{"doc":"This will create symlinks for secret configuration files like prod.secret.exs so the build process can include them in the build. Configuration If you want to use this functionality, in your .mate.exs file you can specify this for every remote. For example like this: config :staging , server : &quot;build-server&quot; , build_path : &quot;/tmp/mate/project&quot; , release_path : &quot;/home/elixir/releases/project&quot; , build_secrets : %{ &quot;prod.secret.exs&quot; =&gt; &quot;/mnt/secrets/prod.secret.exs&quot; }","ref":"Mate.Step.LinkBuildSecrets.html","title":"Mate.Step.LinkBuildSecrets","type":"module"},{"doc":"This will run mix compile on the build server.","ref":"Mate.Step.MixCompile.html","title":"Mate.Step.MixCompile","type":"module"},{"doc":"This will install the mix dependencies.","ref":"Mate.Step.MixDeps.html","title":"Mate.Step.MixDeps","type":"module"},{"doc":"This will run mix phx.digest.clean and mix phx.digest on the build server.","ref":"Mate.Step.MixDigest.html","title":"Mate.Step.MixDigest","type":"module"},{"doc":"This will run mix release --overwrite on the build server.","ref":"Mate.Step.MixRelease.html","title":"Mate.Step.MixRelease","type":"module"},{"doc":"This will run npm run deploy on the build server.","ref":"Mate.Step.NpmBuild.html","title":"Mate.Step.NpmBuild","type":"module"},{"doc":"This will install the front-end dependencies using npm.","ref":"Mate.Step.NpmInstall.html","title":"Mate.Step.NpmInstall","type":"module"},{"doc":"This will prepare the source code for building, for example when using the Mate.Driver.SSH driver it will push the latest commit to the build server.","ref":"Mate.Step.PrepareSource.html","title":"Mate.Step.PrepareSource","type":"module"},{"doc":"This will push the current branch/commit to the build server.","ref":"Mate.Step.SendGitCommit.html","title":"Mate.Step.SendGitCommit","type":"module"},{"doc":"Starts or restarts the new release on the remote release servers.","ref":"Mate.Step.StartRelease.html","title":"Mate.Step.StartRelease","type":"module"},{"doc":"Unarchives the release tarball on the remote deploy servers.","ref":"Mate.Step.UnarchiveRelease.html","title":"Mate.Step.UnarchiveRelease","type":"module"},{"doc":"This will verify Elixir is available in PATH on the build server.","ref":"Mate.Step.VerifyElixir.html","title":"Mate.Step.VerifyElixir","type":"module"},{"doc":"This verifies git both on the local machine and the build server. Local Machine On your local machine it will ensure there is a git remote configured for the current remote (e.g. staging, production) to the build server. It will also get the name of the current branch on your local machine. Build Server On the build server it will ensure that the build path exists, that it is a git repository, that is is configured to receive commits, it is given a hard reset and checkout to the same branch that is currently used on the local machine.","ref":"Mate.Step.VerifyGit.html","title":"Mate.Step.VerifyGit","type":"module"},{"doc":"This will verify node is available in PATH on the build server.","ref":"Mate.Step.VerifyNode.html","title":"Mate.Step.VerifyNode","type":"module"},{"doc":"This module contains some small helper utilities.","ref":"Mate.Utils.html","title":"Mate.Utils","type":"module"},{"doc":"Returns a boolean to determine if the given value is empty. Examples: iex&gt; Mate.Utils.empty?(&quot;&quot;) true iex&gt; Mate.Utils.empty?([]) true iex&gt; Mate.Utils.empty?(nil) true iex&gt; Mate.Utils.empty?(&quot;Hello&quot;) false iex&gt; Mate.Utils.empty?([1,2,3]) false","ref":"Mate.Utils.html#empty?/1","title":"Mate.Utils.empty?/1","type":"function"},{"doc":"Returns the namespace Module name from the current Mix Project. Example: iex&gt; Mate.Utils . module ( ) &quot;Mate&quot;","ref":"Mate.Utils.html#module/0","title":"Mate.Utils.module/0","type":"function"},{"doc":"Returns the sanitized module name as a string. Example: iex&gt; Mate.Utils . module_name ( Mate ) &quot;Mate&quot; iex&gt; Mate.Utils . module_name ( % Mate.Pipeline { } ) &quot;Mate.Pipeline&quot; iex&gt; Mate.Utils . module_name ( &quot;Elixir.Mate&quot; ) &quot;Mate&quot;","ref":"Mate.Utils.html#module_name/1","title":"Mate.Utils.module_name/1","type":"function"},{"doc":"Returns the otp app from the current Mix Project. Example: iex&gt; Mate.Utils . otp_app ( ) :mate","ref":"Mate.Utils.html#otp_app/0","title":"Mate.Utils.otp_app/0","type":"function"},{"doc":"Returns a random id of any given length Examples: iex&gt; Mate.Utils.random_id() &quot;3T440PTEM1IFD64I9R8MU2L2TIAGSF1TRQDH394HCUS5IRJHCGL0&quot; iex&gt; Mate.Utils.random_id(6) &quot;HGEE0AFSH0&quot;","ref":"Mate.Utils.html#random_id/1","title":"Mate.Utils.random_id/1","type":"function"},{"doc":"Prints Mate tasks and their information. mix mate","ref":"Mix.Tasks.Mate.html","title":"Mix.Tasks.Mate","type":"task"},{"doc":"Builds a new release only, no deploying. Command line options -v , --verbose - increases verbosity level (more output!)","ref":"Mix.Tasks.Mate.Build.html","title":"Mix.Tasks.Mate.Build","type":"task"},{"doc":"Builds a new release and deploys it too Command line options -v , --verbose - increases verbosity level (more output!)","ref":"Mix.Tasks.Mate.Deploy.html","title":"Mix.Tasks.Mate.Deploy","type":"task"},{"doc":"Creates a new mate configuration file (.mate.exs) Command line options --docker - create file with Docker driver as default --local - create file with Local driver as default -f , --force - force create file, overwrite if one already exists","ref":"Mix.Tasks.Mate.Init.html","title":"Mix.Tasks.Mate.Init","type":"task"},{"doc":"Mate Customisable Deployment for Elixir / Phoenix Elixir is fun to work with, releasing should be fun too. This project aims to help with that. You can choose to build your release remotely via SSH, locally via Docker or just locally in general. Of course when building locally remember that the system architecture should match with your deploy servers. After building your application, you can also deploy it to one or multiple servers over an SSH connection.","ref":"about.html","title":"About Mate","type":"extras"},{"doc":"It's the inspiration behind this, but I wanted something that is compatible with mix release , something more customisable and a codebase that is better readable. This project aims to be that, but as it is still early if you are looking for something more stable, edeliver might still be the better choice – for now.","ref":"about.html#what-about-edeliver","title":"About Mate - What about edeliver?","type":"extras"},{"doc":"The documentation for mate can be found on hexdocs.pm/mate .","ref":"about.html#documentation","title":"About Mate - Documentation","type":"extras"},{"doc":"mate is available via https://hex.pm/packages/mate . Just add mate to your dependencies in the mix.exs file, you only need it for :dev as you run it locally from your machine. def deps do [ { :mate , &quot;~&gt; 0.1.5&quot; , only : :dev } ] end Then you can get the latest dependencies and use mix mate.init to get started! $ mix deps.get $ mix mate.init","ref":"about.html#installation","title":"About Mate - Installation","type":"extras"},{"doc":"Naming is hard and I wanted something short. Most deployment software seems to stick to a nautical theme with their naming, so I ended up with mate.","ref":"about.html#why-is-it-called-mate","title":"About Mate - Why is it called Mate?","type":"extras"}]